package com.sun.star.smarttags;

import com.sun.star.container.NoSuchElementException;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.lang.XSingleComponentFactory;
import com.sun.star.lib.uno.helper.Factory;
import com.sun.star.lib.uno.helper.WeakBase;
import com.sun.star.registry.XRegistryKey;
import com.sun.star.system.XSystemShellExecute;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;

public final class OOoNameAction extends WeakBase
   implements com.sun.star.lang.XServiceInfo,
              com.sun.star.smarttags.XSmartTagAction 
{
    private final XComponentContext m_xContext;
    private static final String m_implementationName = OOoNameAction.class.getName();
    private static final String[] m_serviceNames = {
        "com.sun.star.smarttags.SmartTagAction" };


    public OOoNameAction( XComponentContext context ) {
        m_xContext = context;
    };

    public static XSingleComponentFactory __getComponentFactory( String sImplementationName ) {
        XSingleComponentFactory xFactory = null;

        if ( sImplementationName.equals( m_implementationName ) )
            xFactory = Factory.createComponentFactory(OOoNameAction.class, m_serviceNames);
        return xFactory;
    }

    public static boolean __writeRegistryServiceInfo( XRegistryKey xRegistryKey ) {
        return Factory.writeRegistryServiceInfo(m_implementationName,
                                                m_serviceNames,
                                                xRegistryKey);
    }

    // com.sun.star.lang.XServiceInfo:
    public String getImplementationName() {
         return m_implementationName;
    }

    public boolean supportsService( String sService ) {
        int len = m_serviceNames.length;

        for( int i=0; i < len; i++) {
            if (sService.equals(m_serviceNames[i]))
                return true;
        }
        return false;
    }

    public String[] getSupportedServiceNames() {
        return m_serviceNames;
    }
    
    // com.sun.star.smarttags.XSmartTagAction:
    public int getSmartTagCount() {
        return 1;
    }
    
    // com.sun.star.smarttags.XSmartTagAction:
    public String getSmartTagName(int nSmartTagIndex) throws com.sun.star.lang.IndexOutOfBoundsException {
        return new String("mynamespace#oooname");
    }

    // com.sun.star.smarttags.XSmartTagAction:
    public String getSmartTagCaption(int nSmartTagIndex, com.sun.star.lang.Locale aLocale) throws com.sun.star.lang.IndexOutOfBoundsException {
        return new String("OOo Name");
    }

    // com.sun.star.smarttags.XSmartTagAction:
    public int getActionCount(String aSmartTagName, com.sun.star.frame.XController xController) {
        return 2;
    }

    // com.sun.star.smarttags.XSmartTagAction:
    public int getActionID(String aSmartTagName, int nActionIndex, com.sun.star.frame.XController xController) throws com.sun.star.lang.IllegalArgumentException {
        return nActionIndex;
    }

    // com.sun.star.smarttags.XSmartTagAction:
    public String getActionCaptionFromID(int nActionID, String aApplicationName, com.sun.star.lang.Locale aLocale, com.sun.star.container.XStringKeyMap xProperties, String aText, String aXML, com.sun.star.frame.XController xController, com.sun.star.text.XTextRange xTarget) throws com.sun.star.lang.IllegalArgumentException {
        if ( 0 == nActionID ) {
            String aRealName = null;
            try {
                aRealName = (String) xProperties.getValue("RealName");
            } catch (NoSuchElementException ex) {
                ex.printStackTrace();
            }
            return new String("Replace with real name: ") + aRealName;
            
        }
        else if ( 1 == nActionID )
            return new String("Look up issuezilla bugs");
        
        return new String();
    }
    
    // com.sun.star.smarttags.XSmartTagAction:
    public void invokeAction(int nActionID, String aApplicationName, com.sun.star.frame.XController xController, com.sun.star.text.XTextRange xTarget, com.sun.star.container.XStringKeyMap xProperties, String aText, String aXML, com.sun.star.lang.Locale aLocale) throws com.sun.star.lang.IllegalArgumentException
    {
        if ( 0 == nActionID ) {
            String aRealName = null;
            try {
                aRealName = (String) xProperties.getValue("RealName");
            } catch (NoSuchElementException ex) {
                ex.printStackTrace();
            }
            xTarget.setString(aRealName);
        }
        else if ( 1 == nActionID ) {
            try {
                final XMultiComponentFactory xFact = m_xContext.getServiceManager();
                final Object xObject = xFact.createInstanceWithContext("com.sun.star.system.SystemShellExecute", m_xContext);
                final XSystemShellExecute xSystemShellExecute = (XSystemShellExecute) UnoRuntime.queryInterface(XSystemShellExecute.class, xObject);
                final String aURLString = "http://qa.openoffice.org/issues/buglist.cgi?issue_type=DEFECT&issue_status=NEW&email1=" + aText + "%40openoffice.org&emailtype1=exact&emailassigned_to1=1&email2=&emailtype2=exact&emailreporter2=1&issueidtype=include&issue_id=&changedin=&votes=&chfieldfrom=&chfieldto=&chfieldvalue=&short_desc=&short_desc_type=allwords&long_desc=&long_desc_type=allwords&issue_file_loc=&issue_file_loc_type=fulltext&status_whiteboard=&status_whiteboard_type=fulltext&keywords=&keywords_type=anytokens&field0-0-0=noop&type0-0-0=noop&value0-0-0=&cmdtype=doit&order=%27%27&Submit+query=Submit+query";
                xSystemShellExecute.execute( aURLString, "", com.sun.star.system.SystemShellExecuteFlags.DEFAULTS );
            } catch( com.sun.star.uno.Exception ex) {
                ex.printStackTrace();
            }
        }
    }
    
    // com.sun.star.lang.XInitialization:
    public void initialize(Object[] aArguments) throws com.sun.star.uno.Exception {
    }
    
    //
    // CURRENTLY NOT USED
    //

    // com.sun.star.smarttags.XSmartTagAction:
    public String getName(com.sun.star.lang.Locale aLocale) {
        return new String("Name");
    }

    // com.sun.star.smarttags.XSmartTagAction:
    public String getDescription(com.sun.star.lang.Locale aLocale) {
        return new String("Description");
    }

    // com.sun.star.smarttags.XSmartTagAction:
    public String getActionNameFromID(int nActionID, com.sun.star.frame.XController xController) throws com.sun.star.lang.IllegalArgumentException {
        return new String();
    }

    // com.sun.star.smarttags.XSmartTagAction:
    public boolean isCaptionDynamic(int nActionID, String aApplicationName, com.sun.star.frame.XController xController, com.sun.star.lang.Locale aLocale) throws com.sun.star.lang.IllegalArgumentException {
        return true;
    }

    // com.sun.star.smarttags.XSmartTagAction:
    public boolean isShowSmartTagIndicator(int nActionID, String aApplicationName, com.sun.star.frame.XController xController, com.sun.star.lang.Locale aLocale) throws com.sun.star.lang.IllegalArgumentException {
        return true;
    }
}
